package generated.eGKmitServices.terminal.apothekenPC;

/**
 * Generated Class
 * 
 */

public class IndexNonce implements PlainData, Codeable {

	private int index;

	private Nonce nonce;

	private Nonce nonceApothekenPC;

	public IndexNonce() {

		index = 0;
		nonce = new Nonce();
		nonceApothekenPC = new Nonce();

	}

	public IndexNonce(int index, Nonce nonce, Nonce nonceApothekenPC) {

		this.index = index;
		this.nonce = nonce;
		this.nonceApothekenPC = nonceApothekenPC;

	}

	public int getIndex() {
		return index;
	}

	public Nonce getNonce() {
		return nonce;
	}

	public Nonce getNonceApothekenPC() {
		return nonceApothekenPC;
	}

	public void setIndex(int index) {
		this.index = index;
	}

	public void setNonce(Nonce nonce) {
		this.nonce = nonce;
	}
	public void setNonceApothekenPC(Nonce nonceApothekenPC) {
		this.nonceApothekenPC = nonceApothekenPC;
	}

	public byte getCode() {
		return Code.INDEXNONCE;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(IndexNonce other) {
		if (this.index != other.index)
			return false;
		if (!this.nonce.equals(other.nonce))
			return false;
		if (!this.nonceApothekenPC.equals(other.nonceApothekenPC))
			return false;
		return true;
	}

	public void copy(IndexNonce from) {
		this.index = from.index;
		this.nonce.copy(from.nonce);
		this.nonceApothekenPC.copy(from.nonceApothekenPC);
	}

	public IndexNonce copy() {
		IndexNonce object = new IndexNonce();
		object.copy(this);
		return object;
	}

}
