package generated.eGKmitServices.terminal.apothekenPC;

/**
 * Generated Class
 * 
 */

public class LeistungserbringerInfo implements SignData, Codeable {

	private String name;

	private PublicKey pubkey;

	private int id;

	public LeistungserbringerInfo() {

		name = new String();
		pubkey = new PublicKey();
		id = 0;

	}

	public LeistungserbringerInfo(String name, PublicKey pubkey, int id) {

		this.name = name;
		this.pubkey = pubkey;
		this.id = id;

	}

	public LeistungserbringerInfo(byte[] name, PublicKey pubkey, int id) {
		this.name = Coding.getInstance().byteToString(name);
		this.pubkey = pubkey;
		this.id = id;

	}

	public String getName() {
		return name;
	}

	public PublicKey getPubkey() {
		return pubkey;
	}

	public int getId() {
		return id;
	}

	public void setName(String name) {

		if (!Coding.getInstance().isValidCardString(name))
			System.err.println("Encoded string " + name + " is longer than "
					+ LengthConstants.LENGTHOFSTRING + " bytes.");
		this.name = name;
	}
	public void setName(byte[] name) {
		setName(Coding.getInstance().byteToString(name));
	}

	public void setPubkey(PublicKey pubkey) {
		this.pubkey = pubkey;
	}
	public void setId(int id) {
		this.id = id;
	}

	public byte getCode() {
		return Code.LEISTUNGSERBRINGERINFO;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(LeistungserbringerInfo other) {
		if (!this.name.equals(other.name))
			return false;
		if (!this.pubkey.equals(other.pubkey))
			return false;
		if (this.id != other.id)
			return false;
		return true;
	}

	public void copy(LeistungserbringerInfo from) {
		this.name = from.name;
		this.pubkey.copy(from.pubkey);
		this.id = from.id;
	}

	public LeistungserbringerInfo copy() {
		LeistungserbringerInfo object = new LeistungserbringerInfo();
		object.copy(this);
		return object;
	}

}
