package generated.eGKmitServices.terminal.apothekenPC;

/**
 * Generated Class
 * 
 */

public class ZertifikatLeistungserbringer implements Codeable {

	private LeistungserbringerInfo data;

	private SignedData signedCert;

	public ZertifikatLeistungserbringer() {

		data = new LeistungserbringerInfo();
		signedCert = new SignedData();

	}

	public ZertifikatLeistungserbringer(SignedData signedCert,
			LeistungserbringerInfo data) {

		this.signedCert = signedCert;
		this.data = data;

	}

	public LeistungserbringerInfo getData() {
		return data;
	}

	public SignedData getSignedCert() {
		return signedCert;
	}

	public void setData(LeistungserbringerInfo data) {
		this.data = data;
	}
	public void setSignedCert(SignedData signedCert) {
		this.signedCert = signedCert;
	}

	public byte getCode() {
		return Code.ZERTIFIKATLEISTUNGSERBRINGER;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(ZertifikatLeistungserbringer other) {
		if (!this.data.equals(other.data))
			return false;
		if (!this.signedCert.equals(other.signedCert))
			return false;
		return true;
	}

	public void copy(ZertifikatLeistungserbringer from) {
		this.data.copy(from.data);
		this.signedCert.copy(from.signedCert);
	}

	public ZertifikatLeistungserbringer copy() {
		ZertifikatLeistungserbringer object = new ZertifikatLeistungserbringer();
		object.copy(this);
		return object;
	}

	public boolean verifyCertificate(PublicKey pubkey) throws Exception {
		return SignedData.verify(pubkey, signedCert, data);
	}

	public static ZertifikatLeistungserbringer generateCertificate(
			PrivateKey issuerPrivateKey, String name, PublicKey pubkey, int id)
			throws Exception {
		LeistungserbringerInfo dataclass = new LeistungserbringerInfo(name,
				pubkey, id);
		SignedData s = SignedData.sign(issuerPrivateKey, dataclass);

		return new ZertifikatLeistungserbringer(s, dataclass);

	}

}
