package generated.eGKmitServices.terminal.arztPC;

import de.uniaugsburg.swt.javacard.terminalinterface.SWTReaderException;

public interface Gate {

	/**
	 * Assertion function for gate constraints
	 */
	public void callConstraints();

	/**
	 * Sends an APDU originating from ArztPC. Write redirection code here.
	 * @param terminal ArztPC which requested the send action
	 * @param port port to send the message to
	 */
	public byte[] transmit(ArztPC terminal, byte[] apdu, int port)
			throws TerminalException, SWTReaderException;

	/**
	 * Called when the original protocol is finished
	 */
	public void finishProtocol(ArztPC terminal);
}
