package generated.eGKmitServices.terminal.arztPC;

/**
 * Generated Class
 * 
 */

public class NotfalldatenNonce implements PlainData, Codeable {

	private Nonce nonce;

	private String daten;

	public NotfalldatenNonce() {

		nonce = new Nonce();
		daten = new String();

	}

	public NotfalldatenNonce(Nonce nonce, String daten) {

		this.nonce = nonce;
		this.daten = daten;

	}

	public NotfalldatenNonce(Nonce nonce, byte[] daten) {
		this.nonce = nonce;
		this.daten = Coding.getInstance().byteToString(daten);

	}

	public Nonce getNonce() {
		return nonce;
	}

	public String getDaten() {
		return daten;
	}

	public void setNonce(Nonce nonce) {
		this.nonce = nonce;
	}
	public void setDaten(String daten) {

		if (!Coding.getInstance().isValidCardString(daten))
			System.err.println("Encoded string " + daten + " is longer than "
					+ LengthConstants.LENGTHOFSTRING + " bytes.");
		this.daten = daten;
	}
	public void setDaten(byte[] daten) {
		setDaten(Coding.getInstance().byteToString(daten));
	}

	public byte getCode() {
		return Code.NOTFALLDATENNONCE;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(NotfalldatenNonce other) {
		if (!this.nonce.equals(other.nonce))
			return false;
		if (!this.daten.equals(other.daten))
			return false;
		return true;
	}

	public void copy(NotfalldatenNonce from) {
		this.nonce.copy(from.nonce);
		this.daten = from.daten;
	}

	public NotfalldatenNonce copy() {
		NotfalldatenNonce object = new NotfalldatenNonce();
		object.copy(this);
		return object;
	}

}
