package generated.eGKmitServices.terminal.arztPC;

/**
 * Generated Class
 * 
 */

public class USendeRezeptdaten extends Usermessage {

	private String ausstellungsdatum;

	private String angabezureinnahme;

	private Arzneimittel arzneimittel;

	public USendeRezeptdaten() {

		ausstellungsdatum = new String();
		angabezureinnahme = new String();
		arzneimittel = new Arzneimittel();

	}

	public USendeRezeptdaten(String ausstellungsdatum,
			String angabezureinnahme, Arzneimittel arzneimittel) {

		this.ausstellungsdatum = ausstellungsdatum;
		this.angabezureinnahme = angabezureinnahme;
		this.arzneimittel = arzneimittel;

	}

	public USendeRezeptdaten(byte[] ausstellungsdatum,
			byte[] angabezureinnahme, Arzneimittel arzneimittel) {
		this.ausstellungsdatum = Coding.getInstance().byteToString(
				ausstellungsdatum);
		this.angabezureinnahme = Coding.getInstance().byteToString(
				angabezureinnahme);
		this.arzneimittel = arzneimittel;

	}

	public Arzneimittel getArzneimittel() {
		return arzneimittel;
	}

	public String getAusstellungsdatum() {
		return ausstellungsdatum;
	}

	public String getAngabezureinnahme() {
		return angabezureinnahme;
	}

	public void setArzneimittel(Arzneimittel arzneimittel) {
		this.arzneimittel = arzneimittel;
	}
	public void setAusstellungsdatum(String ausstellungsdatum) {

		if (!Coding.getInstance().isValidCardString(ausstellungsdatum))
			System.err.println("Encoded string " + ausstellungsdatum
					+ " is longer than " + LengthConstants.LENGTHOFSTRING
					+ " bytes.");
		this.ausstellungsdatum = ausstellungsdatum;
	}
	public void setAusstellungsdatum(byte[] ausstellungsdatum) {
		setAusstellungsdatum(Coding.getInstance().byteToString(
				ausstellungsdatum));
	}

	public void setAngabezureinnahme(String angabezureinnahme) {

		if (!Coding.getInstance().isValidCardString(angabezureinnahme))
			System.err.println("Encoded string " + angabezureinnahme
					+ " is longer than " + LengthConstants.LENGTHOFSTRING
					+ " bytes.");
		this.angabezureinnahme = angabezureinnahme;
	}
	public void setAngabezureinnahme(byte[] angabezureinnahme) {
		setAngabezureinnahme(Coding.getInstance().byteToString(
				angabezureinnahme));
	}

	public byte getCode() {
		return Code.USENDEREZEPTDATEN;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(USendeRezeptdaten other) {
		if (!this.arzneimittel.equals(other.arzneimittel))
			return false;
		if (!this.ausstellungsdatum.equals(other.ausstellungsdatum))
			return false;
		if (!this.angabezureinnahme.equals(other.angabezureinnahme))
			return false;
		return true;
	}

	public void copy(USendeRezeptdaten from) {
		this.arzneimittel.copy(from.arzneimittel);
		this.ausstellungsdatum = from.ausstellungsdatum;
		this.angabezureinnahme = from.angabezureinnahme;
	}

	public USendeRezeptdaten copy() {
		USendeRezeptdaten object = new USendeRezeptdaten();
		object.copy(this);
		return object;
	}

}
