package generated.eGKmitServices.terminal.arztPC;

/**
 * Generated Class
 * 
 */

public class ZertifikatKiosk implements Codeable {

	private ZertifikatKioskData data;

	private SignedData signedCert;

	public ZertifikatKiosk(ZertifikatKioskData data, SignedData signedCert) {

		this.data = data;
		this.signedCert = signedCert;

	}

	public ZertifikatKiosk() {

		data = new ZertifikatKioskData();
		signedCert = new SignedData();

	}

	public ZertifikatKioskData getData() {
		return data;
	}

	public SignedData getSignedCert() {
		return signedCert;
	}

	public void setData(ZertifikatKioskData data) {
		this.data = data;
	}
	public void setSignedCert(SignedData signedCert) {
		this.signedCert = signedCert;
	}

	public byte getCode() {
		return Code.ZERTIFIKATKIOSK;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(ZertifikatKiosk other) {
		if (!this.data.equals(other.data))
			return false;
		if (!this.signedCert.equals(other.signedCert))
			return false;
		return true;
	}

	public void copy(ZertifikatKiosk from) {
		this.data.copy(from.data);
		this.signedCert.copy(from.signedCert);
	}

	public ZertifikatKiosk copy() {
		ZertifikatKiosk object = new ZertifikatKiosk();
		object.copy(this);
		return object;
	}

	public boolean verifyCertificate(PublicKey pubkey) throws Exception {
		return SignedData.verify(pubkey, signedCert, data);
	}

	public static ZertifikatKiosk generateCertificate(
			PrivateKey issuerPrivateKey, String name, PublicKey pubkey, int id)
			throws Exception {
		ZertifikatKioskData dataclass = new ZertifikatKioskData(name, pubkey,
				id);
		SignedData s = SignedData.sign(issuerPrivateKey, dataclass);

		return new ZertifikatKiosk(dataclass, s);

	}

}
