package generated.eGKmitServices.javacard.gesundheitskarte;

/**
 * Generated Class
 * 
 */

public class KeyData implements PlainData, Codeable {

	public Nonce nonce;

	public SymmKey sessionkey;

	public KeyData() {

		nonce = new Nonce();
		sessionkey = new SymmKey();

	}

	public KeyData(Nonce nonce, SymmKey sessionkey) {

		this.nonce = nonce;
		this.sessionkey = sessionkey;

	}

	public byte getCode() {
		return Code.KEYDATA;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(KeyData other) {
		if (!this.nonce.equals(other.nonce))
			return false;
		if (!this.sessionkey.equals(other.sessionkey))
			return false;
		return true;
	}

	public void copy(KeyData from) {
		this.nonce.copy(from.nonce);
		this.sessionkey.copy(from.sessionkey);
	}

}
