package generated.eGKmitServices.javacard.gesundheitskarte;

/**
 * Generated Class
 * 
 */

public class ZertifikatPatient implements Codeable {

	public ZertifikatPatientData data;

	public SignedData signedCert;

	public ZertifikatPatient() {

		data = new ZertifikatPatientData();
		signedCert = new SignedData();

	}

	public ZertifikatPatient(SignedData signedCert, ZertifikatPatientData data) {

		this.signedCert = signedCert;
		this.data = data;

	}

	public byte getCode() {
		return Code.ZERTIFIKATPATIENT;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(ZertifikatPatient other) {
		if (!this.data.equals(other.data))
			return false;
		if (!this.signedCert.equals(other.signedCert))
			return false;
		return true;
	}

	public void copy(ZertifikatPatient from) {
		this.data.copy(from.data);
		this.signedCert.copy(from.signedCert);
	}

	/*PROTECTED REGION ID(generated.eGKmitServices.javacard.gesundheitskarte.ZertifikatPatient) ENABLED START*/

	/*PROTECTED REGION END*/

	public boolean verifyCertificate(PublicKey pubkey) {
		return SignedData.verify(pubkey, signedCert, data);
	}

	public static ZertifikatPatient generateCertificate(
			PrivateKey issuerPrivateKey, byte[] name, PublicKey pubkey,
			short versichertennr, short krankenkassenID, short id) {
		ZertifikatPatientData dataclass = Store.newZertifikatPatientData(name,
				pubkey, versichertennr, krankenkassenID, id);
		SignedData s = SignedData.sign(issuerPrivateKey, dataclass);

		return Store.newZertifikatPatient(s, dataclass);

	}

}
