package generated.eGKmitServices.javacard.heilberufsausweisApotheker;

/**
 * Generated Class
 * 
 */

public class CardData extends Message {

	public Nonce nonce;

	public ZertifikatPatient zertEGK;

	public SignedData sigdaten;

	public EncDataAsymm daten;

	public CardData(Nonce nonce, EncDataAsymm daten, SignedData sigdaten,
			ZertifikatPatient zertEGK) {

		this.nonce = nonce;
		this.daten = daten;
		this.sigdaten = sigdaten;
		this.zertEGK = zertEGK;

	}

	public CardData() {

		nonce = new Nonce();
		zertEGK = new ZertifikatPatient();
		sigdaten = new SignedData();
		daten = new EncDataAsymm();

	}

	public byte getCode() {
		return Code.CARDDATA;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(CardData other) {
		if (!this.nonce.equals(other.nonce))
			return false;
		if (!this.zertEGK.equals(other.zertEGK))
			return false;
		if (!this.sigdaten.equals(other.sigdaten))
			return false;
		if (!this.daten.equals(other.daten))
			return false;
		return true;
	}

	public void copy(CardData from) {
		this.nonce.copy(from.nonce);
		this.zertEGK.copy(from.zertEGK);
		this.sigdaten.copy(from.sigdaten);
		this.daten.copy(from.daten);
	}

}
