package generated.eGKmitServices.javacard.heilberufsausweisApotheker;

import javacard.framework.*;

/**
 * Generated Class
 * 
 */

public class ZertifikatKioskData implements SignData, Codeable {

	public byte[] name;

	public PublicKey pubkey;

	public short id;

	public ZertifikatKioskData() {

		name = new byte[Store.LENGTHOFSTRING];
		pubkey = new PublicKey();
		id = 0;

	}

	public ZertifikatKioskData(byte[] name, PublicKey pubkey, short id) {

		this.name = name;
		this.pubkey = pubkey;
		this.id = id;

	}

	public byte getCode() {
		return Code.ZERTIFIKATKIOSKDATA;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(ZertifikatKioskData other) {
		if (!Arrays.equals(name, other.name))
			return false;
		if (!this.pubkey.equals(other.pubkey))
			return false;
		if (this.id != other.id)
			return false;
		return true;
	}

	public void copy(ZertifikatKioskData from) {

		Arrays.copy(from.name, this.name);

		this.pubkey.copy(from.pubkey);
		this.id = from.id;
	}

}
