package generated.eGKmitServices.javacard.heilberufsausweisApotheker;

/**
 * Generated Class
 * 
 */

public class ZertifikatLeistungserbringer implements Codeable {

	public LeistungserbringerInfo data;

	public SignedData signedCert;

	public ZertifikatLeistungserbringer() {

		data = new LeistungserbringerInfo();
		signedCert = new SignedData();

	}

	public ZertifikatLeistungserbringer(SignedData signedCert,
			LeistungserbringerInfo data) {

		this.signedCert = signedCert;
		this.data = data;

	}

	public byte getCode() {
		return Code.ZERTIFIKATLEISTUNGSERBRINGER;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(ZertifikatLeistungserbringer other) {
		if (!this.data.equals(other.data))
			return false;
		if (!this.signedCert.equals(other.signedCert))
			return false;
		return true;
	}

	public void copy(ZertifikatLeistungserbringer from) {
		this.data.copy(from.data);
		this.signedCert.copy(from.signedCert);
	}

	/*PROTECTED REGION ID(generated.eGKmitServices.javacard.heilberufsausweisApotheker.ZertifikatLeistungserbringer) ENABLED START*/

	/*PROTECTED REGION END*/

	public boolean verifyCertificate(PublicKey pubkey) {
		return SignedData.verify(pubkey, signedCert, data);
	}

	public static ZertifikatLeistungserbringer generateCertificate(
			PrivateKey issuerPrivateKey, byte[] name, PublicKey pubkey, short id) {
		LeistungserbringerInfo dataclass = Store.newLeistungserbringerInfo(
				name, pubkey, id);
		SignedData s = SignedData.sign(issuerPrivateKey, dataclass);

		return Store.newZertifikatLeistungserbringer(s, dataclass);

	}

}
