package generated.eGKmitServices.javacard.heilberufsausweisArzt;

import javacard.framework.*;

/**
 * Generated Class
 * 
 */

public class ZertifikatPatientData implements SignData, Codeable {

	public byte[] name;

	public PublicKey pubkey;

	public short versichertennr;

	public short krankenkassenID;

	public short id;

	public ZertifikatPatientData() {

		name = new byte[Store.LENGTHOFSTRING];
		pubkey = new PublicKey();
		versichertennr = 0;
		krankenkassenID = 0;
		id = 0;

	}

	public ZertifikatPatientData(byte[] name, PublicKey pubkey,
			short versichertennr, short krankenkassenID, short id) {

		this.name = name;
		this.pubkey = pubkey;
		this.versichertennr = versichertennr;
		this.krankenkassenID = krankenkassenID;
		this.id = id;

	}

	public byte getCode() {
		return Code.ZERTIFIKATPATIENTDATA;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(ZertifikatPatientData other) {
		if (!Arrays.equals(name, other.name))
			return false;
		if (!this.pubkey.equals(other.pubkey))
			return false;
		if (this.versichertennr != other.versichertennr)
			return false;
		if (this.krankenkassenID != other.krankenkassenID)
			return false;
		if (this.id != other.id)
			return false;
		return true;
	}

	public void copy(ZertifikatPatientData from) {

		Arrays.copy(from.name, this.name);

		this.pubkey.copy(from.pubkey);
		this.versichertennr = from.versichertennr;
		this.krankenkassenID = from.krankenkassenID;
		this.id = from.id;
	}

}
