package generated.eGKmitServices.terminal.kiosk;

/**
 * Generated Class
 * 
 */

public class Versichertenstammdaten implements SignData, PlainData, Codeable {

	private String name;

	private String versichertennr;

	private int KennummerKrankenkasse;

	private String adresse;

	public Versichertenstammdaten() {

		name = new String();
		versichertennr = new String();
		KennummerKrankenkasse = 0;
		adresse = new String();

	}

	public Versichertenstammdaten(String name, String versichertennr,
			int KennummerKrankenkasse, String adresse) {

		this.name = name;
		this.versichertennr = versichertennr;
		this.KennummerKrankenkasse = KennummerKrankenkasse;
		this.adresse = adresse;

	}

	public Versichertenstammdaten(byte[] name, byte[] versichertennr,
			int KennummerKrankenkasse, byte[] adresse) {
		this.name = Coding.getInstance().byteToString(name);
		this.versichertennr = Coding.getInstance().byteToString(versichertennr);
		this.KennummerKrankenkasse = KennummerKrankenkasse;
		this.adresse = Coding.getInstance().byteToString(adresse);

	}

	public String getName() {
		return name;
	}

	public String getVersichertennr() {
		return versichertennr;
	}

	public int getKennummerKrankenkasse() {
		return KennummerKrankenkasse;
	}

	public String getAdresse() {
		return adresse;
	}

	public void setName(String name) {

		if (!Coding.getInstance().isValidCardString(name))
			System.err.println("Encoded string " + name + " is longer than "
					+ LengthConstants.LENGTHOFSTRING + " bytes.");
		this.name = name;
	}
	public void setName(byte[] name) {
		setName(Coding.getInstance().byteToString(name));
	}

	public void setVersichertennr(String versichertennr) {

		if (!Coding.getInstance().isValidCardString(versichertennr))
			System.err.println("Encoded string " + versichertennr
					+ " is longer than " + LengthConstants.LENGTHOFSTRING
					+ " bytes.");
		this.versichertennr = versichertennr;
	}
	public void setVersichertennr(byte[] versichertennr) {
		setVersichertennr(Coding.getInstance().byteToString(versichertennr));
	}

	public void setKennummerKrankenkasse(int KennummerKrankenkasse) {
		this.KennummerKrankenkasse = KennummerKrankenkasse;
	}

	public void setAdresse(String adresse) {

		if (!Coding.getInstance().isValidCardString(adresse))
			System.err.println("Encoded string " + adresse + " is longer than "
					+ LengthConstants.LENGTHOFSTRING + " bytes.");
		this.adresse = adresse;
	}
	public void setAdresse(byte[] adresse) {
		setAdresse(Coding.getInstance().byteToString(adresse));
	}

	public byte getCode() {
		return Code.VERSICHERTENSTAMMDATEN;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(Versichertenstammdaten other) {
		if (!this.name.equals(other.name))
			return false;
		if (!this.versichertennr.equals(other.versichertennr))
			return false;
		if (this.KennummerKrankenkasse != other.KennummerKrankenkasse)
			return false;
		if (!this.adresse.equals(other.adresse))
			return false;
		return true;
	}

	public void copy(Versichertenstammdaten from) {
		this.name = from.name;
		this.versichertennr = from.versichertennr;
		this.KennummerKrankenkasse = from.KennummerKrankenkasse;
		this.adresse = from.adresse;
	}

	public Versichertenstammdaten copy() {
		Versichertenstammdaten object = new Versichertenstammdaten();
		object.copy(this);
		return object;
	}

}
