package generated.eGKmitServices.terminal.kiosk;

/**
 * Generated Class
 * 
 */

public class ZertifikatPatientData implements SignData, Codeable {

	private String name;

	private PublicKey pubkey;

	private int versichertennr;

	private int krankenkassenID;

	private int id;

	public ZertifikatPatientData() {

		name = new String();
		pubkey = new PublicKey();
		versichertennr = 0;
		krankenkassenID = 0;
		id = 0;

	}

	public ZertifikatPatientData(String name, PublicKey pubkey,
			int versichertennr, int krankenkassenID, int id) {

		this.name = name;
		this.pubkey = pubkey;
		this.versichertennr = versichertennr;
		this.krankenkassenID = krankenkassenID;
		this.id = id;

	}

	public ZertifikatPatientData(byte[] name, PublicKey pubkey,
			int versichertennr, int krankenkassenID, int id) {
		this.name = Coding.getInstance().byteToString(name);
		this.pubkey = pubkey;
		this.versichertennr = versichertennr;
		this.krankenkassenID = krankenkassenID;
		this.id = id;

	}

	public String getName() {
		return name;
	}

	public PublicKey getPubkey() {
		return pubkey;
	}

	public int getVersichertennr() {
		return versichertennr;
	}

	public int getKrankenkassenID() {
		return krankenkassenID;
	}

	public int getId() {
		return id;
	}

	public void setName(String name) {

		if (!Coding.getInstance().isValidCardString(name))
			System.err.println("Encoded string " + name + " is longer than "
					+ LengthConstants.LENGTHOFSTRING + " bytes.");
		this.name = name;
	}
	public void setName(byte[] name) {
		setName(Coding.getInstance().byteToString(name));
	}

	public void setPubkey(PublicKey pubkey) {
		this.pubkey = pubkey;
	}
	public void setVersichertennr(int versichertennr) {
		this.versichertennr = versichertennr;
	}

	public void setKrankenkassenID(int krankenkassenID) {
		this.krankenkassenID = krankenkassenID;
	}

	public void setId(int id) {
		this.id = id;
	}

	public byte getCode() {
		return Code.ZERTIFIKATPATIENTDATA;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(ZertifikatPatientData other) {
		if (!this.name.equals(other.name))
			return false;
		if (!this.pubkey.equals(other.pubkey))
			return false;
		if (this.versichertennr != other.versichertennr)
			return false;
		if (this.krankenkassenID != other.krankenkassenID)
			return false;
		if (this.id != other.id)
			return false;
		return true;
	}

	public void copy(ZertifikatPatientData from) {
		this.name = from.name;
		this.pubkey.copy(from.pubkey);
		this.versichertennr = from.versichertennr;
		this.krankenkassenID = from.krankenkassenID;
		this.id = from.id;
	}

	public ZertifikatPatientData copy() {
		ZertifikatPatientData object = new ZertifikatPatientData();
		object.copy(this);
		return object;
	}

}
