package generated.eGKmitServices.server.krankenkasse;

/**
 * Generated Class
 * 
 */

public class ZertifikatTTPData implements SignData, Codeable {

	private String name;

	private PublicKey pubkey;

	public ZertifikatTTPData() {

		name = new String();
		pubkey = new PublicKey();

	}

	public ZertifikatTTPData(String name, PublicKey pubkey) {

		this.name = name;
		this.pubkey = pubkey;

	}

	public String getName() {
		return name;
	}

	public PublicKey getPubkey() {
		return pubkey;
	}

	public void setName(String name) {

		if (!Coding.getInstance().isValidCardString(name))
			System.err.println("Encoded string " + name + " is longer than "
					+ LengthConstants.LENGTHOFSTRING + " bytes.");
		this.name = name;
	}

	public void setPubkey(PublicKey pubkey) {
		this.pubkey = pubkey;
	}

	public byte getCode() {
		return Code.ZERTIFIKATTTPDATA;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(ZertifikatTTPData other) {
		if (!this.name.equals(other.name))
			return false;
		if (!this.pubkey.equals(other.pubkey))
			return false;
		return true;
	}

	public void copy(ZertifikatTTPData from) {
		this.name = from.name;
		this.pubkey.copy(from.pubkey);
	}

	public ZertifikatTTPData copy() {
		ZertifikatTTPData object = new ZertifikatTTPData();
		object.copy(this);
		return object;
	}

}
