package generated.eGKmitServices.terminal.apothekenPC;

/**
 * Generated Class
 * 
 */

public class ERezeptdaten implements SignData, PlainData, Codeable {

	private Nonce nonce;

	private String ausstellungsdatum;

	private String angabezureinnahme;

	private Arzneimittel arzneimittel;

	private Versichertenstammdaten ausgestelltfuer;

	public ERezeptdaten(Nonce nonce, String ausstellungsdatum,
			String angabezureinnahme, Arzneimittel arzneimittel,
			Versichertenstammdaten ausgestelltfuer) {

		this.nonce = nonce;
		this.ausstellungsdatum = ausstellungsdatum;
		this.angabezureinnahme = angabezureinnahme;
		this.arzneimittel = arzneimittel;
		this.ausgestelltfuer = ausgestelltfuer;

	}

	public ERezeptdaten() {

		nonce = new Nonce();
		ausstellungsdatum = new String();
		angabezureinnahme = new String();
		arzneimittel = new Arzneimittel();
		ausgestelltfuer = new Versichertenstammdaten();

	}

	public Nonce getNonce() {
		return nonce;
	}

	public String getAusstellungsdatum() {
		return ausstellungsdatum;
	}

	public String getAngabezureinnahme() {
		return angabezureinnahme;
	}

	public Arzneimittel getArzneimittel() {
		return arzneimittel;
	}

	public Versichertenstammdaten getAusgestelltfuer() {
		return ausgestelltfuer;
	}

	public void setNonce(Nonce nonce) {
		this.nonce = nonce;
	}
	public void setAusstellungsdatum(String ausstellungsdatum) {

		if (!Coding.getInstance().isValidCardString(ausstellungsdatum))
			System.err.println("Encoded string " + ausstellungsdatum
					+ " is longer than " + LengthConstants.LENGTHOFSTRING
					+ " bytes.");
		this.ausstellungsdatum = ausstellungsdatum;
	}
	public void setAusstellungsdatum(byte[] ausstellungsdatum) {
		setAusstellungsdatum(Coding.getInstance().byteToString(
				ausstellungsdatum));
	}

	public void setAngabezureinnahme(String angabezureinnahme) {

		if (!Coding.getInstance().isValidCardString(angabezureinnahme))
			System.err.println("Encoded string " + angabezureinnahme
					+ " is longer than " + LengthConstants.LENGTHOFSTRING
					+ " bytes.");
		this.angabezureinnahme = angabezureinnahme;
	}
	public void setAngabezureinnahme(byte[] angabezureinnahme) {
		setAngabezureinnahme(Coding.getInstance().byteToString(
				angabezureinnahme));
	}

	public void setArzneimittel(Arzneimittel arzneimittel) {
		this.arzneimittel = arzneimittel;
	}
	public void setAusgestelltfuer(Versichertenstammdaten ausgestelltfuer) {
		this.ausgestelltfuer = ausgestelltfuer;
	}

	public byte getCode() {
		return Code.EREZEPTDATEN;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(ERezeptdaten other) {
		if (!this.nonce.equals(other.nonce))
			return false;
		if (!this.ausstellungsdatum.equals(other.ausstellungsdatum))
			return false;
		if (!this.angabezureinnahme.equals(other.angabezureinnahme))
			return false;
		if (!this.arzneimittel.equals(other.arzneimittel))
			return false;
		if (!this.ausgestelltfuer.equals(other.ausgestelltfuer))
			return false;
		return true;
	}

	public void copy(ERezeptdaten from) {
		this.nonce.copy(from.nonce);
		this.ausstellungsdatum = from.ausstellungsdatum;
		this.angabezureinnahme = from.angabezureinnahme;
		this.arzneimittel.copy(from.arzneimittel);
		this.ausgestelltfuer.copy(from.ausgestelltfuer);
	}

	public ERezeptdaten copy() {
		ERezeptdaten object = new ERezeptdaten();
		object.copy(this);
		return object;
	}

}
