package generated.eGKmitServices.terminal.apothekenPC;

/**
 * Generated Class
 * 
 */

public class NonceStringData implements PlainData, Codeable {

	private Nonce nonce;

	private String s;

	public NonceStringData() {

		nonce = new Nonce();
		s = new String();

	}

	public NonceStringData(Nonce nonce, String s) {

		this.nonce = nonce;
		this.s = s;

	}

	public NonceStringData(Nonce nonce, byte[] s) {
		this.nonce = nonce;
		this.s = Coding.getInstance().byteToString(s);

	}

	public Nonce getNonce() {
		return nonce;
	}

	public String getS() {
		return s;
	}

	public void setNonce(Nonce nonce) {
		this.nonce = nonce;
	}
	public void setS(String s) {

		if (!Coding.getInstance().isValidCardString(s))
			System.err.println("Encoded string " + s + " is longer than "
					+ LengthConstants.LENGTHOFSTRING + " bytes.");
		this.s = s;
	}
	public void setS(byte[] s) {
		setS(Coding.getInstance().byteToString(s));
	}

	public byte getCode() {
		return Code.NONCESTRINGDATA;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(NonceStringData other) {
		if (!this.nonce.equals(other.nonce))
			return false;
		if (!this.s.equals(other.s))
			return false;
		return true;
	}

	public void copy(NonceStringData from) {
		this.nonce.copy(from.nonce);
		this.s = from.s;
	}

	public NonceStringData copy() {
		NonceStringData object = new NonceStringData();
		object.copy(this);
		return object;
	}

}
