package generated.eGKmitServices.terminal.arztPC;

/**
 * Generated Class
 * 
 */

public class PINData implements PlainData, Codeable {

	private Secret pin;

	private Nonce n;

	public PINData() {

		pin = new Secret();
		n = new Nonce();

	}

	public PINData(Secret pin, Nonce n) {

		this.pin = pin;
		this.n = n;

	}

	public Secret getPin() {
		return pin;
	}

	public Nonce getN() {
		return n;
	}

	public void setPin(Secret pin) {
		this.pin = pin;
	}
	public void setN(Nonce n) {
		this.n = n;
	}

	public byte getCode() {
		return Code.PINDATA;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(PINData other) {
		if (!this.pin.equals(other.pin))
			return false;
		if (!this.n.equals(other.n))
			return false;
		return true;
	}

	public void copy(PINData from) {
		this.pin.copy(from.pin);
		this.n.copy(from.n);
	}

	public PINData copy() {
		PINData object = new PINData();
		object.copy(this);
		return object;
	}

}
