package generated.eGKmitServices.terminal.arztPC;

/**
 * Generated Class
 * 
 */

public class StammUndNotfalldaten implements PlainData, Codeable {

	private String notfalldaten;

	private Nonce nonce;

	private int anzahlRezepte;

	private Versichertenstammdaten vsd;

	public StammUndNotfalldaten() {

		notfalldaten = new String();
		nonce = new Nonce();
		anzahlRezepte = 0;
		vsd = new Versichertenstammdaten();

	}

	public StammUndNotfalldaten(String notfalldaten, Nonce nonce,
			int anzahlRezepte, Versichertenstammdaten vsd) {

		this.notfalldaten = notfalldaten;
		this.nonce = nonce;
		this.anzahlRezepte = anzahlRezepte;
		this.vsd = vsd;

	}

	public StammUndNotfalldaten(byte[] notfalldaten, Nonce nonce,
			int anzahlRezepte, Versichertenstammdaten vsd) {
		this.notfalldaten = Coding.getInstance().byteToString(notfalldaten);
		this.nonce = nonce;
		this.anzahlRezepte = anzahlRezepte;
		this.vsd = vsd;

	}

	public String getNotfalldaten() {
		return notfalldaten;
	}

	public Nonce getNonce() {
		return nonce;
	}

	public int getAnzahlRezepte() {
		return anzahlRezepte;
	}

	public Versichertenstammdaten getVsd() {
		return vsd;
	}

	public void setNotfalldaten(String notfalldaten) {

		if (!Coding.getInstance().isValidCardString(notfalldaten))
			System.err.println("Encoded string " + notfalldaten
					+ " is longer than " + LengthConstants.LENGTHOFSTRING
					+ " bytes.");
		this.notfalldaten = notfalldaten;
	}
	public void setNotfalldaten(byte[] notfalldaten) {
		setNotfalldaten(Coding.getInstance().byteToString(notfalldaten));
	}

	public void setNonce(Nonce nonce) {
		this.nonce = nonce;
	}
	public void setAnzahlRezepte(int anzahlRezepte) {
		this.anzahlRezepte = anzahlRezepte;
	}

	public void setVsd(Versichertenstammdaten vsd) {
		this.vsd = vsd;
	}

	public byte getCode() {
		return Code.STAMMUNDNOTFALLDATEN;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(StammUndNotfalldaten other) {
		if (!this.notfalldaten.equals(other.notfalldaten))
			return false;
		if (!this.nonce.equals(other.nonce))
			return false;
		if (this.anzahlRezepte != other.anzahlRezepte)
			return false;
		if (!this.vsd.equals(other.vsd))
			return false;
		return true;
	}

	public void copy(StammUndNotfalldaten from) {
		this.notfalldaten = from.notfalldaten;
		this.nonce.copy(from.nonce);
		this.anzahlRezepte = from.anzahlRezepte;
		this.vsd.copy(from.vsd);
	}

	public StammUndNotfalldaten copy() {
		StammUndNotfalldaten object = new StammUndNotfalldaten();
		object.copy(this);
		return object;
	}

}
