package generated.eGKmitServices.javacard.gesundheitskarte;

import javacard.framework.*;

/**
 * Generated Class
 * 
 */

public class ERezeptdaten implements SignData, PlainData, Codeable {

	public Nonce nonce;

	public byte[] ausstellungsdatum;

	public byte[] angabezureinnahme;

	public Arzneimittel arzneimittel;

	public Versichertenstammdaten ausgestelltfuer;

	public ERezeptdaten(Nonce nonce, byte[] ausstellungsdatum,
			byte[] angabezureinnahme, Arzneimittel arzneimittel,
			Versichertenstammdaten ausgestelltfuer) {

		this.nonce = nonce;
		this.ausstellungsdatum = ausstellungsdatum;
		this.angabezureinnahme = angabezureinnahme;
		this.arzneimittel = arzneimittel;
		this.ausgestelltfuer = ausgestelltfuer;

	}

	public ERezeptdaten() {

		nonce = new Nonce();
		ausstellungsdatum = new byte[Store.LENGTHOFSTRING];
		angabezureinnahme = new byte[Store.LENGTHOFSTRING];
		arzneimittel = new Arzneimittel();
		ausgestelltfuer = new Versichertenstammdaten();

	}

	public byte getCode() {
		return Code.EREZEPTDATEN;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(ERezeptdaten other) {
		if (!this.nonce.equals(other.nonce))
			return false;
		if (!Arrays.equals(ausstellungsdatum, other.ausstellungsdatum))
			return false;
		if (!Arrays.equals(angabezureinnahme, other.angabezureinnahme))
			return false;
		if (!this.arzneimittel.equals(other.arzneimittel))
			return false;
		if (!this.ausgestelltfuer.equals(other.ausgestelltfuer))
			return false;
		return true;
	}

	public void copy(ERezeptdaten from) {
		this.nonce.copy(from.nonce);

		Arrays.copy(from.ausstellungsdatum, this.ausstellungsdatum);

		Arrays.copy(from.angabezureinnahme, this.angabezureinnahme);

		this.arzneimittel.copy(from.arzneimittel);
		this.ausgestelltfuer.copy(from.ausgestelltfuer);
	}

}
