package generated.eGKmitServices.javacard.heilberufsausweisApotheker;

import javacard.framework.ISOException;

public class ListOfERezept implements Codeable, PlainData, SignData {

	private short size;
	public ERezept[] elems;
	public short index;

	public ListOfERezept(short size) {
		this.size = size;
		elems = new ERezept[size];
		for (short i = 0; i < elems.length; i++)
			elems[i] = new ERezept();
	}

	//don't use this function if you use get(key), set(value) or containsKey(key)

	public void add(ERezept e) {
		elems[index++].copy(e);
	}

	//returns the number of elems that are stored in the list
	public short size() {
		return index;
	}

	public boolean hasFree() {
		return index < elems.length;
	}

	public short index() {
		return index;
	}

	//**************************************************

	public boolean isEmpty() {
		return index == 0;
	}

	public void clear() {
		index = 0;
	}

	public boolean contains(ERezept e) {
		for (short i = 0; i < index; i++) {
			if (elems[i].equals(e)) {
				return true;
			}
		}
		return false;
	}

	public void remove(ERezept e) {
		removeIndex(containsAndIndex(e));
	}

	public void removeAll(ERezept e) {
		removeAllIndex(containsAndIndex(e), e);
	}

	public ERezept at(short index) {
		return elems[index];
	}

	public void copy(ListOfERezept from) {
		this.index = from.index;
		for (int i = 0; i < from.index; i++) {
			this.elems[i].copy(from.elems[i]);

		}

	}

	//****************************************************

	private short containsAndIndex(ERezept e) {
		for (short i = 0; i < index; i++) {
			if (elems[i].equals(e)) {
				return i;
			}
		}
		return -1;
	}

	private void removeIndex(short ind) {
		if (ind >= 0 && ind < index) {
			for (short i = ind; (short) (i + 1) < index; i++) {
				elems[i].copy(elems[(short) (i + 1)]);
			}
			index--;
		}
	}

	private void removeAllIndex(short ind, ERezept e) {
		if (ind >= 0) {
			short i = ind;
			short found = 1;
			for (short j = (short) (ind + 1); j < index; j++) {
				if (!elems[j].equals(e)) {
					elems[i++].copy(elems[j]);
				} else {
					found++;
				}
			}
			index -= found;
		}
	}

	public boolean equals(ListOfERezept o) {
		if (size != o.size)
			return false;
		for (int i = 0; i < o.size; i++)
			if (!elems[i].equals(o.elems[i]))
				return false;
		return true;
	}

	public byte getCode() {
		return Code.LISTOFEREZEPT;
	}

}
