package generated.eGKmitServices.javacard.heilberufsausweisApotheker;

/**
 * Generated Class
 * 
 */

public class ZertifikatTrustedThirdParty implements Codeable {

	public ZertifikatTTPData data;

	public SignedData signedCert;

	public ZertifikatTrustedThirdParty() {

		data = new ZertifikatTTPData();
		signedCert = new SignedData();

	}

	public ZertifikatTrustedThirdParty(SignedData signedCert,
			ZertifikatTTPData data) {

		this.signedCert = signedCert;
		this.data = data;

	}

	public byte getCode() {
		return Code.ZERTIFIKATTRUSTEDTHIRDPARTY;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(ZertifikatTrustedThirdParty other) {
		if (!this.data.equals(other.data))
			return false;
		if (!this.signedCert.equals(other.signedCert))
			return false;
		return true;
	}

	public void copy(ZertifikatTrustedThirdParty from) {
		this.data.copy(from.data);
		this.signedCert.copy(from.signedCert);
	}

	/*PROTECTED REGION ID(generated.eGKmitServices.javacard.heilberufsausweisApotheker.ZertifikatTrustedThirdParty) ENABLED START*/

	/*PROTECTED REGION END*/

	public boolean verifyCertificate(PublicKey pubkey) {
		return SignedData.verify(pubkey, signedCert, data);
	}

	public static ZertifikatTrustedThirdParty generateCertificate(
			PrivateKey issuerPrivateKey, byte[] name, PublicKey pubkey) {
		ZertifikatTTPData dataclass = Store.newZertifikatTTPData(name, pubkey);
		SignedData s = SignedData.sign(issuerPrivateKey, dataclass);

		return Store.newZertifikatTrustedThirdParty(s, dataclass);

	}

}
