package generated.eGKmitServices.javacard.heilberufsausweisArzt;

/**
 * Generated Class
 * 
 */

public class ZertifikatKiosk implements Codeable {

	public ZertifikatKioskData data;

	public SignedData signedCert;

	public ZertifikatKiosk(ZertifikatKioskData data, SignedData signedCert) {

		this.data = data;
		this.signedCert = signedCert;

	}

	public ZertifikatKiosk() {

		data = new ZertifikatKioskData();
		signedCert = new SignedData();

	}

	public byte getCode() {
		return Code.ZERTIFIKATKIOSK;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(ZertifikatKiosk other) {
		if (!this.data.equals(other.data))
			return false;
		if (!this.signedCert.equals(other.signedCert))
			return false;
		return true;
	}

	public void copy(ZertifikatKiosk from) {
		this.data.copy(from.data);
		this.signedCert.copy(from.signedCert);
	}

	/*PROTECTED REGION ID(generated.eGKmitServices.javacard.heilberufsausweisArzt.ZertifikatKiosk) ENABLED START*/

	/*PROTECTED REGION END*/

	public boolean verifyCertificate(PublicKey pubkey) {
		return SignedData.verify(pubkey, signedCert, data);
	}

	public static ZertifikatKiosk generateCertificate(
			PrivateKey issuerPrivateKey, byte[] name, PublicKey pubkey, short id) {
		ZertifikatKioskData dataclass = Store.newZertifikatKioskData(name,
				pubkey, id);
		SignedData s = SignedData.sign(issuerPrivateKey, dataclass);

		return Store.newZertifikatKiosk(dataclass, s);

	}

}
