package generated.eGKmitServices.terminal.kiosk;

/**
 * Generated Class
 * 
 */

public class ZertifikatPatient implements Codeable {

	private ZertifikatPatientData data;

	private SignedData signedCert;

	public ZertifikatPatient() {

		data = new ZertifikatPatientData();
		signedCert = new SignedData();

	}

	public ZertifikatPatient(SignedData signedCert, ZertifikatPatientData data) {

		this.signedCert = signedCert;
		this.data = data;

	}

	public ZertifikatPatientData getData() {
		return data;
	}

	public SignedData getSignedCert() {
		return signedCert;
	}

	public void setData(ZertifikatPatientData data) {
		this.data = data;
	}
	public void setSignedCert(SignedData signedCert) {
		this.signedCert = signedCert;
	}

	public byte getCode() {
		return Code.ZERTIFIKATPATIENT;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(ZertifikatPatient other) {
		if (!this.data.equals(other.data))
			return false;
		if (!this.signedCert.equals(other.signedCert))
			return false;
		return true;
	}

	public void copy(ZertifikatPatient from) {
		this.data.copy(from.data);
		this.signedCert.copy(from.signedCert);
	}

	public ZertifikatPatient copy() {
		ZertifikatPatient object = new ZertifikatPatient();
		object.copy(this);
		return object;
	}

	public boolean verifyCertificate(PublicKey pubkey) throws Exception {
		return SignedData.verify(pubkey, signedCert, data);
	}

	public static ZertifikatPatient generateCertificate(
			PrivateKey issuerPrivateKey, String name, PublicKey pubkey,
			int versichertennr, int krankenkassenID, int id) throws Exception {
		ZertifikatPatientData dataclass = new ZertifikatPatientData(name,
				pubkey, versichertennr, krankenkassenID, id);
		SignedData s = SignedData.sign(issuerPrivateKey, dataclass);

		return new ZertifikatPatient(s, dataclass);

	}

}
