package generated.eGKmitServices.server.krankenkasse;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import java.util.ArrayList;
@XmlAccessorType(XmlAccessType.FIELD)
public class ListOfVersichertenstammdaten
		implements
			Codeable,
			PlainData,
			SignData {

	private ArrayList<Versichertenstammdaten> list;
	public ListOfVersichertenstammdaten() {
		list = new ArrayList<Versichertenstammdaten>();
	}

	public Versichertenstammdaten get(String key) throws ServiceException {
		for (Versichertenstammdaten item : list)
			if (item.getVersichertennr().equals(key)) {
				Versichertenstammdaten value = new Versichertenstammdaten();
				value.copy(item);
				return value;
			}
		throw new ServiceException("List: key does not exist");
	}
	public void set(Versichertenstammdaten value) {
		Versichertenstammdaten item;
		try {
			item = get(value.getVersichertennr());
			list.remove(item);
		} catch (ServiceException e) {
		}
		list.add(value);
	}
	public Boolean containsKey(String key) {
		try {
			get(key);
			return true;
		} catch (ServiceException e) {
			return false;
		}
	}
	public Versichertenstammdaten first() {
		return list.get(0);
	}
	public boolean isEmpty() {
		return list.isEmpty();
	}
	public Boolean remove(String key) {
		try {
			list.remove(get(key));
			return true;
		} catch (ServiceException e) {
			return false;
		}
	}

	public boolean equals(ListOfVersichertenstammdaten o) {
		if (list.size() != o.list.size())
			return false;
		for (int i = 0; i < list.size(); i++)
			if (!list.get(i).equals(o.list.get(i)))
				return false;
		return true;
	}

	public byte getCode() {
		return Code.LISTOFVERSICHERTENSTAMMDATEN;
	}

	public short index() {
		return (short) list.size();
	}

	public void copy(ListOfVersichertenstammdaten from) {
		for (int i = 0; i < from.list.size(); i++) {
			this.list.add(i, new Versichertenstammdaten());
			this.list.get(i).copy(from.list.get(i));
		}
	}

}
