package generated.eGKmitServices.server.krankenkasse;

/**
 * Generated Class
 * 
 */

public class UpdateAuth implements SignData, Codeable {

	private Nonce nonce;

	private Versichertenstammdaten data;

	public UpdateAuth() {

		nonce = new Nonce();
		data = new Versichertenstammdaten();

	}

	public UpdateAuth(Nonce nonce, Versichertenstammdaten data) {

		this.nonce = nonce;
		this.data = data;

	}

	public Nonce getNonce() {
		return nonce;
	}

	public Versichertenstammdaten getData() {
		return data;
	}

	public void setNonce(Nonce nonce) {
		this.nonce = nonce;
		this.nonce.setNonce(nonce.getNonce());
	}
	public void setData(Versichertenstammdaten data) {
		this.data = data;
		this.data.setName(data.getName());
		this.data.setVersichertennr(data.getVersichertennr());
		this.data.setKennummerKrankenkasse(data.getKennummerKrankenkasse());
		this.data.setAdresse(data.getAdresse());
	}

	public byte getCode() {
		return Code.UPDATEAUTH;
	}

	/**
	 * This method deeply checks equality of classes.
	 *
	 * @param other Class to compare with
	 * @return true, if values of all attributes are equal
	 */

	public boolean equals(UpdateAuth other) {
		if (!this.nonce.equals(other.nonce))
			return false;
		if (!this.data.equals(other.data))
			return false;
		return true;
	}

	public void copy(UpdateAuth from) {
		this.nonce.copy(from.nonce);
		this.data.copy(from.data);
	}

	public UpdateAuth copy() {
		UpdateAuth object = new UpdateAuth();
		object.copy(this);
		return object;
	}

}
